diff --git a/libswscale/swscale_unscaled.c b/libswscale/swscale_unscaled.c
index 058f2b94db..9abfae5c04 100644
--- a/libswscale/swscale_unscaled.c
+++ b/libswscale/swscale_unscaled.c
@@ -1942,6 +1942,7 @@ void ff_get_unscaled_swscale(SwsContext *c)
          dstFormat == AV_PIX_FMT_GBRP12LE || dstFormat == AV_PIX_FMT_GBRP12BE ||
          dstFormat == AV_PIX_FMT_GBRP14LE || dstFormat == AV_PIX_FMT_GBRP14BE ||
          dstFormat == AV_PIX_FMT_GBRP16LE || dstFormat == AV_PIX_FMT_GBRP16BE ||
+         dstFormat == AV_PIX_FMT_GBRAP10LE || dstFormat == AV_PIX_FMT_GBRAP10LE ||
          dstFormat == AV_PIX_FMT_GBRAP12LE || dstFormat == AV_PIX_FMT_GBRAP12BE ||
          dstFormat == AV_PIX_FMT_GBRAP16LE || dstFormat == AV_PIX_FMT_GBRAP16BE ))
         c->swscale = Rgb16ToPlanarRgb16Wrapper;
@@ -1951,6 +1952,7 @@ void ff_get_unscaled_swscale(SwsContext *c)
          srcFormat == AV_PIX_FMT_GBRP10LE || srcFormat == AV_PIX_FMT_GBRP10BE ||
          srcFormat == AV_PIX_FMT_GBRP12LE || srcFormat == AV_PIX_FMT_GBRP12BE ||
          srcFormat == AV_PIX_FMT_GBRP14LE || srcFormat == AV_PIX_FMT_GBRP14BE ||
+         dstFormat == AV_PIX_FMT_GBRAP10LE || dstFormat == AV_PIX_FMT_GBRAP10LE ||
          srcFormat == AV_PIX_FMT_GBRAP12LE || srcFormat == AV_PIX_FMT_GBRAP12BE ||
          srcFormat == AV_PIX_FMT_GBRAP16LE || srcFormat == AV_PIX_FMT_GBRAP16BE) &&
         (dstFormat == AV_PIX_FMT_RGB48LE  || dstFormat == AV_PIX_FMT_RGB48BE  ||
@@ -1997,6 +1999,7 @@ void ff_get_unscaled_swscale(SwsContext *c)
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRP12) ||
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRP14) ||
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRP16) ||
+        IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRAP10) ||
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRAP12) ||
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_GBRAP16) ||
         IS_DIFFERENT_ENDIANESS(srcFormat, dstFormat, AV_PIX_FMT_RGB444) ||
diff --git a/tests/ref/fate/filter-pixfmts-copy b/tests/ref/fate/filter-pixfmts-copy
index bf0977a96a..4694fb7676 100644
--- a/tests/ref/fate/filter-pixfmts-copy
+++ b/tests/ref/fate/filter-pixfmts-copy
@@ -19,7 +19,7 @@ bgra                3934fb81a602dfa7d29420b1a66f0fd8
 bgra64le            b71d75a928aac14cb768403e6f6a9910
 bgra64le            b71d75a928aac14cb768403e6f6a9910
 gbrap               98d30987407c51e5620921e11d40a4ff
-gbrap10le           3a046be0d38289dda5d8fdbd0f34aaf5
+gbrap10le           2a7392e14b21b1f9457526a071236a6d
 gbrap10le           2a7392e14b21b1f9457526a071236a6d
 gbrap12le           5f1d8c663d4c28863e687192433b34a4
 gbrap12le           5f1d8c663d4c28863e687192433b34a4
diff --git a/tests/ref/fate/filter-pixfmts-crop b/tests/ref/fate/filter-pixfmts-crop
index 09b7ca9a27..9dd6f097b5 100644
--- a/tests/ref/fate/filter-pixfmts-crop
+++ b/tests/ref/fate/filter-pixfmts-crop
@@ -19,7 +19,7 @@ bgra                e66a5f68ba463cbc89fce23a61bb5203
 bgra64le            dd29ec9aba43aa3e8f9f5b9a93ca8831
 bgra64le            dd29ec9aba43aa3e8f9f5b9a93ca8831
 gbrap               188cd467fe7ae7d85ae9ca8bdfa07739
-gbrap10le           c8505df07f9eeb413f943b5f4d686c0b
+gbrap10le           c2b6e35f8b7ca363a7ec021ccdf31d1f
 gbrap10le           c2b6e35f8b7ca363a7ec021ccdf31d1f
 gbrap12le           3f80453c1ac6c5d1b2febf3ef141b476
 gbrap12le           3f80453c1ac6c5d1b2febf3ef141b476
diff --git a/tests/ref/fate/filter-pixfmts-field b/tests/ref/fate/filter-pixfmts-field
index 5779469d41..7dfa0c3299 100644
--- a/tests/ref/fate/filter-pixfmts-field
+++ b/tests/ref/fate/filter-pixfmts-field
@@ -19,7 +19,7 @@ bgra                66d6e0846990fff0f09a07c43c3add71
 bgra64le            9e2def541e51bc6e77fbffbff7fa146a
 bgra64le            9e2def541e51bc6e77fbffbff7fa146a
 gbrap               08a28b79dbd19246d1a94e3466af3624
-gbrap10le           a5cfc53fbd96fcdf83b8b655fe25bf67
+gbrap10le           4017c5d8c124438eb9aefa107db58d3b
 gbrap10le           4017c5d8c124438eb9aefa107db58d3b
 gbrap12le           886207e5aa379a0312485b94e5fd5edd
 gbrap12le           886207e5aa379a0312485b94e5fd5edd
diff --git a/tests/ref/fate/filter-pixfmts-fieldorder b/tests/ref/fate/filter-pixfmts-fieldorder
index 216ca3e769..e62768ab3d 100644
--- a/tests/ref/fate/filter-pixfmts-fieldorder
+++ b/tests/ref/fate/filter-pixfmts-fieldorder
@@ -19,7 +19,7 @@ bgra                5967b559257dbb6784f93b9d2bef4edd
 bgra64le            5029192d0f32383c9f25f8e7da7cb5a0
 bgra64le            5029192d0f32383c9f25f8e7da7cb5a0
 gbrap               00afb65d44bea99c31b318fdbeb3be10
-gbrap10le           7ddbc3ffb7cb6b7e59c866ff99ca5a16
+gbrap10le           52278021718ec370903dccc923dc8bf6
 gbrap10le           52278021718ec370903dccc923dc8bf6
 gbrap12le           ae2d6db2c9c825f06d92389de21263d2
 gbrap12le           ae2d6db2c9c825f06d92389de21263d2
diff --git a/tests/ref/fate/filter-pixfmts-hflip b/tests/ref/fate/filter-pixfmts-hflip
index 96dc08c528..02ca74006a 100644
--- a/tests/ref/fate/filter-pixfmts-hflip
+++ b/tests/ref/fate/filter-pixfmts-hflip
@@ -19,7 +19,7 @@ bgra                275f05a382bcbc9bc77c06b79e1d8a71
 bgra64le            1b15c01c94cf9af89273da1d1f994cff
 bgra64le            1b15c01c94cf9af89273da1d1f994cff
 gbrap               bf6a2b2f206fbbb332a718fb570d7cb7
-gbrap10le           927aa36653525bc3d9e9add84d52d7a3
+gbrap10le           262f0501633ea4670020fae8ac6835e2
 gbrap10le           262f0501633ea4670020fae8ac6835e2
 gbrap12le           88a85c1b3c5e19e299fdd209b73ac1ba
 gbrap12le           88a85c1b3c5e19e299fdd209b73ac1ba
diff --git a/tests/ref/fate/filter-pixfmts-il b/tests/ref/fate/filter-pixfmts-il
index c2c1bd339d..4ce79c0237 100644
--- a/tests/ref/fate/filter-pixfmts-il
+++ b/tests/ref/fate/filter-pixfmts-il
@@ -19,7 +19,7 @@ bgra                e6ae08f06f157297296b319a249dddf5
 bgra64le            d1aa975fa03ce226008396b30a653420
 bgra64le            d1aa975fa03ce226008396b30a653420
 gbrap               575ff1fe5d7585ed82da1db35f106e4c
-gbrap10le           522cf76fa2253286ddede13a6b91397a
+gbrap10le           553a1f439d8184dc400432d3f786fbce
 gbrap10le           553a1f439d8184dc400432d3f786fbce
 gbrap12le           e3b5342c8e47820f2de7e2dd61872312
 gbrap12le           e3b5342c8e47820f2de7e2dd61872312
diff --git a/tests/ref/fate/filter-pixfmts-null b/tests/ref/fate/filter-pixfmts-null
index bf0977a96a..4694fb7676 100644
--- a/tests/ref/fate/filter-pixfmts-null
+++ b/tests/ref/fate/filter-pixfmts-null
@@ -19,7 +19,7 @@ bgra                3934fb81a602dfa7d29420b1a66f0fd8
 bgra64le            b71d75a928aac14cb768403e6f6a9910
 bgra64le            b71d75a928aac14cb768403e6f6a9910
 gbrap               98d30987407c51e5620921e11d40a4ff
-gbrap10le           3a046be0d38289dda5d8fdbd0f34aaf5
+gbrap10le           2a7392e14b21b1f9457526a071236a6d
 gbrap10le           2a7392e14b21b1f9457526a071236a6d
 gbrap12le           5f1d8c663d4c28863e687192433b34a4
 gbrap12le           5f1d8c663d4c28863e687192433b34a4
diff --git a/tests/ref/fate/filter-pixfmts-transpose b/tests/ref/fate/filter-pixfmts-transpose
index 851f0ea91f..f62055429c 100644
--- a/tests/ref/fate/filter-pixfmts-transpose
+++ b/tests/ref/fate/filter-pixfmts-transpose
@@ -19,7 +19,7 @@ bgra                f2fe61e08446900ad209f2c586997e15
 bgra64le            faaef6d280f92e7e8abdd9fa4a61f7b5
 bgra64le            faaef6d280f92e7e8abdd9fa4a61f7b5
 gbrap               0899b3af50d35a63bfecb419a5b29968
-gbrap10le           1e7a177186c222e1d885ea9ae109bb81
+gbrap10le           db4e4861010cbbf726492fad282d5813
 gbrap10le           db4e4861010cbbf726492fad282d5813
 gbrap12le           714fe318af81a46f83655c6e7e13351e
 gbrap12le           714fe318af81a46f83655c6e7e13351e
diff --git a/tests/ref/fate/filter-pixfmts-vflip b/tests/ref/fate/filter-pixfmts-vflip
index 2de72485cc..b141128187 100644
--- a/tests/ref/fate/filter-pixfmts-vflip
+++ b/tests/ref/fate/filter-pixfmts-vflip
@@ -19,7 +19,7 @@ bgra                0af63cc2ffd61af252df93cc767de358
 bgra64le            45feb93863055282447d1ff89c5158bf
 bgra64le            45feb93863055282447d1ff89c5158bf
 gbrap               421c56a25f88d58b9361f5c7bb368e21
-gbrap10le           cc927d069d03410f828b35c5db1000b1
+gbrap10le           43bde7bd6a676c6ac33dbcc4c72762f3
 gbrap10le           43bde7bd6a676c6ac33dbcc4c72762f3
 gbrap12le           6ef8a3ac4129ec23c34aec14ac41f249
 gbrap12le           6ef8a3ac4129ec23c34aec14ac41f249